//
// connection_manager.cpp
// ~~~~~~~~~~~~~~~~~~~~~~
//

#include "connection_manager.hpp"
#include <algorithm>
#include <boost/bind.hpp>

namespace mpre {
  namespace network {

    void connection_manager::start(connection_ptr c){
      connections_.insert(c);
      c->start();
    }

    void connection_manager::stop(connection_ptr c){
      connections_.erase(c);
      c->stop();
    }

    void connection_manager::stop_all() {
      std::for_each(connections_.begin(), connections_.end(),
		    boost::bind(&connection::stop, _1));
      connections_.clear();
    }

    void connection_manager::check_keepalive(connection_ptr c){
      c->check_keepalive();
    }

    void connection_manager::check_all_keepalive(){
            std::for_each(connections_.begin(), connections_.end(),
		    boost::bind(&connection::check_keepalive, _1));
    }


  } // namespace network
} // namespace mpre
